/* Kadohito Ohsuga*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include <pthread.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_STROPTS_H
#include <stropts.h>
#endif
#ifdef HAVE_POLL_H
#include <poll.h>
#include <sys/poll.h>
#endif
#ifdef HAVE_SELECT_H
#include <sys/select.h>
#endif
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include <strings.h>
#include <limits.h>
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <signal.h>
#include <setjmp.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <sys/uio.h>
#include <assert.h>
#include <errno.h>
#include <sys/mman.h>

#include "wcol.h"
#include "socket.h"
#include "sigs.h"
#include "msg.h"
#include "sim_stat.h"
#include "misc.h"
#include "http.h"
#include "sess.h"

extern int n_proxy;

int dhr_hash1(char *host, char *object, int n){

  int i;
  register int hash_value = 0;
  register char *tmp;
  char ctoi;

  if((host == NULL) || (object == NULL))
    return -1;

  tmp = host;

  while(*tmp != '\0'){
    hash_value += *tmp;
    tmp++;
  }
 
  tmp = object;

  while(*tmp != '\0'){
    hash_value += *tmp;
    tmp++;
  }

  return hash_value % n;
}

int dhr_hash2(char *host, char *object, int n){

  int i;
  int hash_value1 = dhr_hash1(host, object, n);
  register int hash_value2 = 0;
  register char *tmp;
  char ctoi;

  if((host == NULL) || (object == NULL) || (hash_value1 < 0))
    return -1;

  tmp = host;

  while(*tmp != '\0'){
    hash_value2 += *tmp;
    tmp++;
  }
 
  tmp = object;

  while(*tmp != '\0'){
    hash_value2 += *tmp;
    tmp++;
  }

  if((hash_value2 % (n - 1)) >= hash_value1)
    return hash_value2 % (n - 1) + 1;
  else
    return hash_value2 % (n - 1);
 
}

void
dhr_proxy_failure(sess_t *sessp){

    DoHalfServerCloseSess(sessp);
    if(sessp->dhr_state == 'A'){
      sessp->dhr_hash = dhr_hash2(sessp->servername,
                                    sessp->serverpath, n_proxy);
      sessp->dhr_state = 'S';
    }
    if(sessp->dhr_state == 'B'){
      sessp->dhr_hash = dhr_hash1(sessp->servername,
                                    sessp->serverpath, n_proxy);
      sessp->dhr_state = 'S';
    }
    if(sessp->dhr_state == 'M'){
      sessp->dhr_hash = -1;
      sessp->dhr_state = 'E';
    }
    sessp->state = STATE_QUERY_ADDR;

}
