/*
 * simple stat routines
 *          by k-chinen@is.aist-nara.ac.jp, 1999
 *
 * $Id$
 */


#define SIM_REC_NAMELEN     (64)


typedef struct {
    pthread_mutex_t busy;
    char name[SIM_REC_NAMELEN];
    long max;
    long count;
    long v_max;
    long v_min;
    long *hcount;
    long igcount;
    long vsum;
} sim_hist_rec;

int sim_hist_clear(sim_hist_rec *srec);
int sim_hist_alloc_new(sim_hist_rec *addr, char *name, int sz, long *ar);
sim_hist_rec* sim_hist_new(char *name, int sz);

int sim_hist_reset(sim_hist_rec *rec);

int sim_hist_add_value(sim_hist_rec *rec, long cv);
int sim_hist_average(sim_hist_rec *rec);
double sim_hist_average_d(sim_hist_rec *rec);

int sim_hist_percentail(sim_hist_rec *rec, int ratio);


int sim_hist_show(sim_hist_rec *rec, FILE *fp);

#if 0
int sim_hist_show(sim_hist_rec *rec, FILE *fp);
int sim_hist_show_lock(sim_hist_rec *rec, FILE *fp);
int sim_hist_show_lock_fd(sim_hist_rec *rec, int ofd);
int sim_hist_show_HTML_nolock_fd(sim_hist_rec *rec, int ofd);
int sim_hist_show_skip_lock_fd(sim_hist_rec *rec, int ofd, int sk);
int sim_hist_show_short(sim_hist_rec *rec, FILE *fp);
#endif


